﻿// ------------------------------------------------------------------------------------
//
// ftMscLibHello                                                 Ulrich Müller 20.11.09
//      FishHello auf Basis der ftMscLib.DLL
//
// ------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using TX = ftMscLibHello.ftMscLib;
using cs = System.Console;

namespace ftMscLibHello {
  class Program {
    static uint ftHandle;
    static uint errCode;
    const uint txOK = 0x00000000;
    const int txWarten = 44;
    const int ctxMain = 0;
    const int Taster = 2;
    const int LampeRot = 4;
    const int LampeGruen = 5;

    static void Main(string[] args) {
      short wert = 0;
      bool ok = false;
      cs.WriteLine("HelloftMscLib-Test an COM4 gestartet");

      // --- Herstellen der Verbindung ---
      TX.ftxInitLib();
      ftHandle = TX.ftxOpenComDevice("COM4", 38400, ref errCode);
      if (errCode != txOK) {
        cs.WriteLine("ControllerProblem.Open"); cs.Read();
        return;
      }
      TX.ftxStartTransferArea(ftHandle);
      // --- Konfigurieren der Universal-Eingänge ---
      TX.SetFtUniConfig(ftHandle, ctxMain, Taster, 1, true);
      Thread.Sleep(txWarten);

      cs.WriteLine("--- Zum Blinken : I3-Taster ---");
      do {
        TX.GetInIOValue(ftHandle, ctxMain, Taster, ref wert, ref ok);
        Thread.Sleep(txWarten);
      } while (wert == 0);

      cs.WriteLine("Bei der Arbeit");
      for (int i = 0; i < 10; i++) {
        TX.SetOutPwmValues(ftHandle, ctxMain, LampeRot, 512);
        TX.SetOutPwmValues(ftHandle, ctxMain, LampeGruen, 0);
        Thread.Sleep(444);
        TX.SetOutPwmValues(ftHandle, ctxMain, LampeRot, 0);
        TX.SetOutPwmValues(ftHandle, ctxMain, LampeGruen, 512);
        Thread.Sleep(333);
      }
      TX.SetOutPwmValues(ftHandle, ctxMain, LampeGruen, 0);
      cs.WriteLine("Das war's");

      // --- Schließen der Verbindung ---
      TX.ftxStopTransferArea(ftHandle);
      TX.ftxCloseDevice(ftHandle);
      TX.ftxCloseLib();
      cs.WriteLine("--- FINIS : Enter-Taste ---");
      cs.Read();
    }
  }
}
